/*
 * 助利宝商户交易额统计
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Data;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class HelpProfitMerTradeSummayController : BaseController
    {
        public HelpProfitMerTradeSummayController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 助利宝商户交易额统计列表

        /// <summary>
        /// 根据条件查询助利宝商户交易额统计列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(HelpProfitMerTradeSummay data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询助利宝商户交易额统计列表

        /// <summary>
        /// 助利宝商户交易额统计列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(HelpProfitMerTradeSummay data, string CreateDateData, string MakerCode, string MerchantId, string BrandId, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            string condition = " and Status>-1";
            var UserId = 0;
            //商户
            if (!string.IsNullOrEmpty(MerchantId))
            {
                var posInfo = db.PosMerchantInfo.FirstOrDefault(m => m.MerchantNo == MerchantId);
                condition += " and MerchantId=" + posInfo.Id;
            }
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                var userInfo = db.UserForMakerCode.FirstOrDefault(m => m.MakerCode == MakerCode) ?? new UserForMakerCode();
                UserId = userInfo.UserId;
            }
            //品牌
            if (!string.IsNullOrEmpty(BrandId))
            {
                condition += " and BrandId=" + BrandId;
            }
            //交易时间
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0].Replace("-", "");
                string end = datelist[1].Replace("-", "");
                condition += " and TradeDate >= '" + start + "' and TradeDate <= '" + end + "' ";
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitMerTradeSummay", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //品牌信息
                int Brand = int.Parse(function.CheckInt(dic["BrandId"].ToString()));
                KqProducts kqProducts = db.KqProducts.FirstOrDefault(m => m.Id == Brand) ?? new KqProducts();
                dic["BrandName"] = kqProducts.Name;

                //商户信息
                int Merchant = int.Parse(function.CheckInt(dic["MerchantId"].ToString()));
                PosMerchantInfo posMerchantInfo = db.PosMerchantInfo.FirstOrDefault(m => m.Id == Merchant) ?? new PosMerchantInfo();
                dic["posMerchantInfo"] = posMerchantInfo.MerchantNo + "--" + posMerchantInfo.MerchantName;
            }

            Dictionary<string, object> other = new Dictionary<string, object>();

            decimal DAmount = 0;//总交易额
            decimal pAmount = 0;//个人交易额
            decimal tAmount = 0;//团队交易额
            DataTable dt = OtherMySqlConn.dtable("select sum(TradeAmount) from HelpProfitMerTradeSummay Where 1=1" + condition);
            DataTable dt1 = OtherMySqlConn.dtable("SELECT SUM(TradeAmount) pTradeAmount FROM HelpProfitMerTradeSummay WHERE (MerchantId IN(SELECT MerchantId FROM HelpProfitMerIds WHERE UserId=" + UserId + "))" + condition);
            DataTable dt2 = OtherMySqlConn.dtable("SELECT SUM(TradeAmount) tTradeAmount FROM HelpProfitMerTradeSummay WHERE (MerchantId IN(SELECT MerchantId FROM HelpProfitMerIds WHERE UserId IN(SELECT Id from Users WHERE ParentNav like '%," + UserId + ",%' OR Id=" + UserId + ")))" + condition);
            if (dt.Rows.Count > 0)
            {
                DAmount = decimal.Parse(function.CheckNum(dt.Rows[0][0].ToString()));
            }
            if (dt1.Rows.Count > 0)
            {
                pAmount = decimal.Parse(function.CheckNum(dt1.Rows[0][0].ToString()));
            }
            if (dt2.Rows.Count > 0)
            {
                tAmount = decimal.Parse(function.CheckNum(dt2.Rows[0][0].ToString()));
            }
            other.Add("DAmount", DAmount);
            other.Add("pAmount", pAmount);
            other.Add("tAmount", tAmount);
            obj.Add("other", other);
            return Json(obj);
        }

        #endregion

        #region 增加助利宝商户交易额统计

        /// <summary>
        /// 增加或修改助利宝商户交易额统计信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加助利宝商户交易额统计

        /// <summary>
        /// 增加或修改助利宝商户交易额统计信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(HelpProfitMerTradeSummay data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("HelpProfitMerTradeSummay", Fields, 0);
            AddSysLog(data.Id.ToString(), "HelpProfitMerTradeSummay", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改助利宝商户交易额统计

        /// <summary>
        /// 增加或修改助利宝商户交易额统计信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            HelpProfitMerTradeSummay editData = db.HelpProfitMerTradeSummay.FirstOrDefault(m => m.Id == Id) ?? new HelpProfitMerTradeSummay();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改助利宝商户交易额统计

        /// <summary>
        /// 增加或修改助利宝商户交易额统计信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(HelpProfitMerTradeSummay data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitMerTradeSummay", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "HelpProfitMerTradeSummay", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除助利宝商户交易额统计信息

        /// <summary>
        /// 删除助利宝商户交易额统计信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitMerTradeSummay", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitMerTradeSummay", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitMerTradeSummay", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitMerTradeSummay", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitMerTradeSummay", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitMerTradeSummay", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("HelpProfitMerTradeSummay", Sort, Id);

            AddSysLog(Id.ToString(), "HelpProfitMerTradeSummay", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.HelpProfitMerTradeSummay.Add(new HelpProfitMerTradeSummay()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "HelpProfitMerTradeSummay", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(HelpProfitMerTradeSummay data, string MerchantIdSelect, string BrandIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();


            string condition = " and Status>-1";
            //商户
            if (!string.IsNullOrEmpty(MerchantIdSelect))
            {
                condition += " and MerchantId=" + MerchantIdSelect;
            }
            //品牌
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitMerTradeSummay", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "HelpProfitMerTradeSummay", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
